﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Services;
namespace SimpleChat
{
    public partial class chat : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (Session["login"] != "true")
            {
                Response.Redirect("default.aspx");
            }
            string user_id = Session["username"].ToString();
            if (!IsPostBack)
            {
                txtusername.Value = user_id;
                //===========load sym
                var db = new ehsanDataContext();
                string b = "";
                foreach (var t in db.sc_smileys)
                {
                    b += string.Format(@"<a onclick=""insert_s('{0}')""><img src=""s/{1}.gif"" /></a>", t.smileys_text, t.smileys_code);
                }
                lbl_sym.Text = b;
            }
        }
        [WebMethod]
        public string add_smileys_to_message(string message)
        {
            var db = new ehsanDataContext();
            string b = message;
            foreach (var t in db.sc_smileys)
            {
                b.Replace(t.smileys_text, "<img src='s/" + t.smileys_code + ".gif' />");
            }
            return b;
        }
        [WebMethod]
        public static string get_new_msg(string username)
        {
            string b = "";
            string user_id = username;
            var db = new ehsanDataContext();
            var user_messages = db.sc_messages.Where(c => c.receiver_username == user_id && c.read_flag == false);
            if (user_messages.Count() == 0)
            {
            }
            else
            {
                foreach (var t in user_messages)
                {
                    string b0 = t.message;
                    foreach (var t1 in db.sc_smileys)
                    {
                        b0 = b0.Replace(t1.smileys_text.ToLower(), "<img src='s/" + t1.smileys_code + ".gif' />");
                        b0 = b0.Replace(t1.smileys_text.ToUpper(), "<img src='s/" + t1.smileys_code + ".gif' />");
                    }
                    b += "<div class='box bgreen'>" + "<strong>" + t.sender_username + ":</strong><br />" + b0 + "<hr>" + t.datetime.ToString() + "</div>";
                    t.read_flag = true;
                }
                db.SubmitChanges();

                return b;
            }
            return "";
        }
        //=============================================
        [WebMethod]
        public static int send_message(string breceiver, string bmessage, string username)
        {
            string _Rusername = breceiver;
            string _message = bmessage;
            string _Susername = username;
            var db = new ehsanDataContext();
            var q = db.sc_users.Where(c => c.username == _Rusername);
            if (q.Count() == 0)
            {
                return 1;
            }
            if (_Rusername == _Susername)
            {
                return 1;
            }
            sc_message ms = new sc_message()
            {
                message = _message,
                read_flag = false,
                receiver_username = _Rusername,
                sender_username = _Susername,
                datetime = DateTime.Now
            };
            db.sc_messages.InsertOnSubmit(ms);
            db.SubmitChanges();
            return 0;
        }

    }
}